=== debian/changelog ===
ortp (1:5.3.105-1) unstable; urgency=medium

  * New upstream version 5.3.105

 -- Victor Seva <vseva@debian.org>  Sun, 23 Feb 2025 00:39:24 +0100

ortp (1:5.3.104-2) unstable; urgency=medium

  * Set upstream metadata fields: Repository.
  * debian/libortp16.shlibs: fix dependency

 -- Victor Seva <vseva@debian.org>  Thu, 06 Feb 2025 16:54:25 +0100

ortp (1:5.3.104-1) unstable; urgency=medium

  * add myself to Uploaders. wrap-and-sort -sat
  * Use secure copyright file specification URI.
  * Set upstream metadata fields: Repository-Browse.
  * debian/gbp.conf: use pristine-tar for imports
  * New upstream version 5.3.104
  * remove fix-spelling patch
  * refresh debian/patches
  * debian/patch: cmake files are arch dependant
  * debian/rules: build shared libs
  * refresh debian/copyright
  * remove empty debian/patches/to_upstream
  * update stack dependencies

 -- Victor Seva <vseva@debian.org>  Thu, 06 Feb 2025 12:50:51 +0100
